'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var Checkbox = /** @class */ (function (_super) {
    __extends(Checkbox, _super);
    function Checkbox() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.isControlled = function (prop) { return prop in _this.props; };
        _this.state = {
            isChecked: _this.props.defaultIsChecked
        };
        _this.handleChange = function (event) {
            var checked = event.currentTarget.checked;
            var onChange = _this.props.onChange;
            if (_this.isControlled("isChecked")) {
                onChange(event);
            }
            else {
                _this.setState({
                    isChecked: checked
                }, function () { return onChange(event); });
            }
        };
        return _this;
    }
    // We don't write props value to state, when we deal with controlled components.
    // When props are changed - component will be rerendered with new prop value.
    // So, we just take this new value and use in `render` method.
    Checkbox.prototype.getState = function () {
        var _this = this;
        return Object.keys(this.state).reduce(function (resultState, stateProp) {
            var stateFromProps = _this.props[stateProp];
            var stateFromState = _this.state[stateProp];
            resultState[stateProp] = _this.isControlled(stateProp)
                ? stateFromProps
                : stateFromState;
            return resultState;
        }, this.state);
    };
    Checkbox.prototype.render = function () {
        var isChecked = this.getState().isChecked;
        var _a = this.props, label = _a.label, containerClassName = _a.containerClassName, disabled = _a.disabled, iconEl = _a.iconEl, iconClassName = _a.iconClassName, labelClassName = _a.labelClassName, name = _a.name;
        return (React.createElement("label", { className: containerClassName },
            React.createElement("input", { name: name, type: "checkbox", checked: isChecked, onChange: this.handleChange, disabled: disabled, "data-testid": "checkbox" }),
            iconEl ? React.createElement("span", { className: iconClassName }, iconEl) : null,
            label ? React.createElement("span", { className: labelClassName }, label) : null));
    };
    Checkbox.defaultProps = {
        defaultIsChecked: false,
        onChange: function () { },
        disabled: false
    };
    return Checkbox;
}(React.PureComponent));

exports.Checkbox = Checkbox;
